<?php namespace awp;
require_once "DBManager.php";
class DBTable
{
	
	public string $name;
	public array $fields;
	public object $dataTypesValidators;
	
	
	
	public function __construct($tableName, $fields)
	{

		$exampleFields = array(
			(object)["name" => "", "type" => "", "length"=> 255, "nullable"=>true, "unique"=>false, "default"=>""],
		);
		
		$dbSetup = \awp\DBManager::getInstance();

		$this->name = sanitize_key($tableName);
		$this->fields = $fields;
		
		//Get Default and custom validators.
		$this->dataTypesValidators = apply_filters("DataTypesValidators", array());
		$this->fields = apply_filters("ValidateFormStructure", $this);
		
		
		/*
		//add_action("init", function() use($fields)
		{
			$this->fields = apply_filters("ValidateFormStructure", $fields);
		}//);
		
		add_filter("ValidateFormStructure", function($input) {  return $this->DefaultStructureVlaidator($input); } ); //do in singleton
		*/
		
		//$this->fields =$this->DefaultStructureVlaidator($fields);
	}

	private function GetField($name)
	{
		for($i=0; $i<count($this->fields); $i++){
			if($this->fields[$i]->name == $name)
				return $this->fields[$i];
		}

		echo "Cannot Find field with name: {$name}.<br/>";
		debug_print_backtrace();
		die();
	}


	public function TableName()
	{
		global $wpdb;
		return $wpdb->prefix.$this->name;
	}
	
	//TODO: use key: for  Primary, Unique and Candidate. (Foregn key may need anoter value for refrence)
	// jsut raed first_char_to_upper(key) to get values P, U, C, F
	public function CrateTable()
	{
		global $wpdb;

		$charset = $wpdb->get_charset_collate();
		$tableName = $wpdb->prefix . $this->name;

		//if($this->TableExists($tableName)) return;

		$rows = array();

		$sql = "CREATE TABLE {$tableName} (";
		$primaryKeyName = null;
		//$unique = array();

		for($i=0; $i<count($this->fields); $i++)
		{
			$field = $this->fields[$i];
			$name = ($field->name);
			$length = property_exists($field, "length") ? $field->length : null;


			if(is_array($length))
			{
				$length = "";

				for($j=0; $j<count($field->length); $j++)
				{
					$item = $field->length[$j];
					if($j != 0)
						$length .= ", ";
					$length .= is_numeric($item) ? $item : "'{$item}'";
				}
			}

			$type = $field->type . (!empty($length) ? "({$length})":"" );
			$default = isset($field->default) && !empty($field->default) ? " DEFAULT '" . $field->default . "'" : "";
			$nullable =  isset($field->nullable) && !$field->nullable ? " NOT NULL" : "";
			$autoIncrement = isset($field->autoIncrement) && $field->autoIncrement ? " AUTO_INCREMENT" : "";
			$unique = isset($field->unique) && $field->unique ? " UNIQUE" : "";
			//if(isset($field->unique) && $field->unique) $unique[] = "`".$name."`";
			
			//$primaryKey = isset($field->primaryKey) && $field->primaryKey ? " PRIMARY KEY" : "";
			//$primaryKey = isset($field->primary) && $field->primary ? " PRIMARY KEY" : $primaryKey;

			$pkTrue = (isset($field->primaryKey) && $field->primaryKey) || (isset($field->primary) && $field->primary);
			
			$primaryKeyName = empty($primaryKeyName) && $pkTrue ? $name : $primaryKeyName;

			$sql .=  ($i!=0?",":"") . "\n\t`{$name}` {$type}". $default . $nullable . $autoIncrement . $unique /*. $primaryKey*/;
		}
		$sql .= ",\n\tPRIMARY KEY ({$primaryKeyName})";
		
		//if(count($unique)) $sql .= ",\n\tUNIQUE(" . implode(", ", $unique) . ")";
		
		
		$sql .="\n) {$charset};";

		//print_r($sql);
		//die();

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );
		
		if($wpdb->last_error !== '')
		{
    		$wpdb->print_error();
    		die();
		}
		
		 $wpdb->get_results();
    	
	}

	private function TableExists($tableName)
	{
		global $wpdb;

		$query = $wpdb->prepare( 
			"SHOW TABLES LIKE '%s';", 
			\esc_sql( $tableName ) 
		);

		if ( $wpdb->get_var( $query ) == $tableName ) {
		    return true;
		}
	}

	public function DeleteTable()
	{
		global $wpdb;

		$tableName = $wpdb->prefix . $this->name;
		if(!$this->TableExists($tableName)) return;

	    $sql = "DROP TABLE IF EXISTS {$tableName}";
	    $wpdb->query($sql);
	    
	    //delete_option('option name');
	}

	public function UpdateRow($rowData, $where, $dataFormat = [null], $whereFormat =[null])
	{

		global $wpdb;
	    $tableName = $wpdb->prefix.$this->name;
	    $queryData = $this->GetWhereString($where);

	    if(empty($dataFormat))
	    {
	    	$dataKeys = array_keys($rowData);
	    	for($i=0; $i<count($dataKeys); $i++)
	    	{
	    		$dataFormat[] = "%s";
	    	}
	    }

	    if(empty($whereFormat))
	    {
	    	$whereKeys = array_keys($where);
	    	for($i=0; $i<count($whereKeys); $i++)
	    	{
	    		$whereFormat[] = "%s";
	    	}
	    }
	    //var_dump($rowData);echo"\r\n";
	    //var_dump($queryData->labeled);echo"\r\n";
		$r = $wpdb->update( $tableName, (array)$rowData, (array)$queryData->labeled /*, $dataFormat, $whereFormat*/ );

     	return $r;
	}

	public function GetRows($where=array(), $select = array(), $order = null, $limmit = null)
	{
		global $wpdb;
	    $tableName = $wpdb->prefix.$this->name;

	    ini_set('display_errors', 1);
		ini_set('display_startup_errors', 1);
		error_reporting(E_ALL);

		$selectString = "";
		if(empty($select))
		{
			$selectString = "*";
		}
		elseif(is_array($select) && array_keys($select) === range(0, count($select) - 1))
		{
			for($i=0; $i<count($select); $i++)
			{
				$selectString .= $i > 0 ? ", " : " ";
				$selectString .=  $select[$i];
			}
		}
		elseif(is_array($select)) //associative array
		{
			$selectKeys = array_keys($select);
			for($i=0; $i<count($selectKeys); $i++)
			{
				$selectString .= $i > 0 ? ", " : " ";
				$selectString .=  $selectKeys[$i] . ($select[$selectKeys[$i]] != $selectKeys[$i] ? " AS {$select[$selectKeys[$i]]}" : "");
			}
		}
		else // object
		{
			$selectKeys = array_keys(get_object_vars($select));
			for($i=0; $i<count($selectKeys); $i++)
			{
				$key = $selectKeys[$i];
				$selectString .= $i > 0 ? ", " : " ";
				$selectString .=  $selectKeys[$i] . ($select->$key != $selectKeys[$i]? " AS {$select->$key}" : "");
			}
		}

	    $queryDataP = $this->GetWhereString($where);
	    
	    if($order !== null)
	    {
	    	$queryDataP->string .= " ORDER BY {$order}";
	    }
	    
	    $regLimmit = null;
	    //regex: Digit 1, offset, can be 7 characters < 1m. The second digit, limmit, can only be 3 chars long, < 1000.
	    if( $limmit !== null && (is_int($limmit) || preg_match("/^(\d{1,7}),(\d{1,3})$/", str_replace(' ', '', $limmit), $regLimmit)) )
	    {
	    	if(!count($regLimmit)>1)
	    		$queryDataP->string .= " LIMIT {$regLimmit[1]}, {$$regLimmit[2]}";
	    	else
	    		$queryDataP->string .= " LIMIT {$limmit}";
	    }
	    //echo"\r\n";var_dump("SELECT {$selectString} FROM $tableName ".$queryDataP->string);
	    //echo"\r\n";var_dump($queryDataP->values);echo"\r\n";
	    $queryData = array("SELECT {$selectString} FROM $tableName ".$queryDataP->string, $queryDataP->values);
	    
	    
	    $query = "";
	    if(empty($queryDataP->values))
	    {
	    	$query = $queryData[0];
	    }
	    else
	    {
	    	$query =call_user_func_array([$wpdb, "prepare"], $queryData);
	    }

		$data = $wpdb->get_results($query);


		return $data;
	}

	public function InsertRow($rowData)
	{
		global $wpdb;
	    $tableName = $wpdb->prefix.$this->name;


		for($i=0; $i<count($this->fields); $i++)
		{
			$tableData = $this->fields[$i];
			if(property_exists($rowData, $tableData->name))
			{
				$rowName = $tableData->name;
				
				if(!$this->ValidateInput($tableData, $rowData->$rowName))
				{
					echo "Failed to validate {$tableData->name}.";
					die();
					return false;
				}
			}
			elseif(isset($tableData->required) && $tableData->required)
			{
				echo "{$tableData->name} is required.";
				die();
				return false;
			}
		}


     	return $wpdb->insert( $tableName, (array)$rowData);
	}

	public function DeleteRow($where)
	{
		global $wpdb;
	    $tableName = $wpdb->prefix.$this->name;

	    $queryData = $this->GetWhereString($where);

	    return $wpdb->delete( $tableName, $queryData->labeled, $queryData->markers);

	}

	private function GetWhereString($input)
	{
		//WHY ISNT IT WORKING!!!! LOOK AT EXAMPLE
		$example = array((object)["key"=>"id", "modifier"=>"=", "value"=>null, "marker"=>"%s" ]);

	    $whereString = "";
	    $whereValues = array();
	    $whereLabeled = array(); //FOR DELETE FUNCTION
	    $whereMarkers = array();//FOR DELETE BUT MAY BE USEFUL

	    if(!is_array($input) || $this->IsAssoc($input))
	    {
	    	$input = array($input);
	    }
	    $inputKeys = array_keys($input);
	    for ($i=0; $i<count($inputKeys); $i++)
	    {
	    	$queryItem = (object)$input[$inputKeys[$i]];
	    	$key = isset($queryItem->key)? $queryItem->key : "id";
	    	$modifier = isset($queryItem->modifier)? $queryItem->modifier : "=";
	    	$marker = isset($queryItem->marker)? $queryItem->marker : "%s";
	    	$value = isset($queryItem->value)? $queryItem->value : null;

	    	//var_dump($queryItem);
	    	if($i ==0) 
	    		$whereString = "WHERE ";
	    	else 
	    		$whereString .= " AND ";

	    	if(isset($queryItem->value))
	    	{
	    		$whereString .= "{$key} ". strtoupper($modifier) . " '{$marker}'";
	    		$whereValues[] = $value;
	    		$whereLabeled[$key] = $value;
	    		$whereMarkers[] = $marker;
	    	}
	    }
	    
	    $whereString = $whereString == "WHERE " ? "" : $whereString;

	    return (object)[
	    	"string" => $whereString, 
	    	"values" => $whereValues, 
	    	"labeled" => $whereLabeled, 
	    	"markers" => $whereMarkers
	    ];
	}

	private function IsAssoc($arr)
	{
	    if (array() === $arr) return false;
	    return array_keys($arr) !== range(0, count($arr) - 1);
	}

	public function ValidateInput($fieldData, $input)
	{
		$type = $fieldData->type;
		if(\awp\DBManager::getInstance()->ValidateTypeStructure($this, $fieldData->name, $type))
		{
			$validator = $this->dataTypesValidators->$type;
			/*
			var_dump($input);
			var_dump($fieldData);
			echo "<br/>";
			var_dump($validator($fieldData, $input));
			echo "<br/>";//*/
			return $validator($fieldData, $input);
		}
	}
	
	//depricated functions
	public static function ByteString($len = 16)
	{
		trigger_error("DBTable::ByteString() depricated use \ByteString() from libs/generate.php instead.");
		return \ByteString($len);
	}

	public static function HexString($byteString = 8)
	{
		trigger_error("DBTable::HexString() depricated use \HexString() from libs/generate.php instead.");
		return \HexString($byteString);
	}

	public static function HexToByte($hexString, $len=8)
	{
		trigger_error("DBTable::HexToByte() depricated use \HexToByte() from libs/generate.php instead.");
		return \HexToByte($hexString, $len);
	}

	public static function UUID($byteString = 16)
	{
		trigger_error("DBTable::UUID() depricated use \UUID() from libs/generate.php instead.");
    	return \UUID($byteString);
	}

}

?>