window.addEventListener("load", function() {
	
	let customInputElements = document.querySelectorAll("input[data-custom-input]");
	
	for(let i=0; i<customInputElements.length; i++)
	{
		let type = customInputElements[i].getAttribute("data-custom-input");
		let value = customInputElements[i].getAttribute("value");
		let name = customInputElements[i].getAttribute("name");
		
		let newElement;
		switch (type)
		{
			case "dictionary":
				newElement = CreateInputElement().dictionary(name, value);
				break;
		}
		
		
		customInputElements[i].insertAdjacentElement("afterend", newElement);
		customInputElements[i].remove();
	}
	

});

let CreateInputElement = function()
{
	
	this.dictionary = function(name, data){
		
		
		let wrapper = new Element({tagName:"div", classList:"customInput"});
		
		let AddRow = function(parent, data = {}){
			
			
			
			let row = new Element({tagName:"div", preditor:parent});
			let keyVal = new Element({tagName:"input", preditor:row, name:name+"[index][key]"});
			let icon = new Element({tagName:"span", preditor:row, classList:"dictionaryArrow"});
			let valVal = new Element({tagName:"input", preditor:row, name:name+"[index][value]"});
			
			
			if(data.key !== undefined)
			{
				console.log(data);
				keyVal.value = data.key;
				valVal.value = data.value;
			}
			
			row.SetIndex = function(index){
				keyVal.name = name+"[" + index + "][key]";
				valVal.name = name+"[" + index + "][value]";
			}
			
			icon.addEventListener("click", function(e){
				e.target.parentNode.remove();
				FixIndexes();
			});
			
			FixIndexes();
		}
		
		let FixIndexes = function(){
			let children = wrapper.childNodes;
			
			let offset = 0;
			for(let i=0; i<children.length; i++)
			{
				if(children[i].SetIndex != undefined)
					children[i].SetIndex(i+offset);
				else
					offset--;
			}
			
		}
		
		let item = JSON.parse(data);
		
		let keys = Object.keys(item);
		let values = Object.values(item);
		
		for(let i=0; i<values.length; i++)
		{
			let key = keys[i];
			let value = values[i];
			AddRow(wrapper, {key: key, value: value});
		}
		
		
		let adder = new Element({tagName:"div", preditor:wrapper, classList:"dictionaryAdder", children: new TextNode("Add Row")});
		adder.addEventListener("click", function(){
			AddRow(wrapper);
		});
		
		FixIndexes();
		
		
		return wrapper;
	}
	
	return this;
}